<div class="slider">
	<div class="slider__container" data-slider-container>
		{{#each main.slides}}
			<article data-slider-slide class="slider__slide" style="background-image: url({{image}})">
				<div class="slider__slide-wrapper">
					<i class="slider__quote-icon">’’</i>
					<h4 class="slider__title">{{title}}</h4>
					<p class="slider__text">{{text}}</p>
				</div>
			</article>
		{{/each}}
	</div>

	<div class="slider__controls">
		{{#each main.slides}}
			<button type="button" class="slider__button{{#ifFirst @index}} active{{/ifFirst}}" data-slider-control></button>
		{{/each}}
	</div>

	<button type="button" class="slider__next" data-slider-next></button>
	<button type="button" class="slider__prev" data-slider-prev></button>
</div>

<script type="text/javascript">
	(function () {
		var __slice = Array.prototype.slice;

		function querySelectorAll(val, el) {
			return el ? __slice.call(el.querySelectorAll(val)) : __slice.call(document.querySelectorAll(val));
		}

		function getSupportedCSSProperty(arr) {
			var doc = document.documentElement;
			var len = arr.length;

			for (var i = 0; i < len; i++) {
				if (arr[i] in doc.style) {
					return arr[i];
				}
			}
		}

		var activeIndex = 0;
		var transform = getSupportedCSSProperty(['transform', 'MozTransform', 'WebkitTransform', 'msTransform', 'OTransform']);
		var $container = document.querySelector('[data-slider-container]');
		var $slides = querySelectorAll('[data-slider-slide]');
		var $controls = querySelectorAll('[data-slider-control]');
		var $next = document.querySelector('[data-slider-next]');
		var $prev = document.querySelector('[data-slider-prev]');
		var length = $slides.length;

		function handleChange() {
			$container.setAttribute('style', transform + ': translateX(' + activeIndex * -100 + '%);');

			$controls.forEach(function($control, i) {
				if (i === activeIndex) {
					$control.classList.add('active');
				} else {
					$control.classList.remove('active');
				}
			});
		}

		$controls.forEach(function($control, i) {
			$control.addEventListener('click', function() {
				activeIndex = i;
				handleChange();
			}, false);
		});

		$next.addEventListener('click', function() {
			activeIndex = activeIndex + 1 > $slides.length - 1 ? 0 : activeIndex + 1;
			handleChange();
		}, false);

		$prev.addEventListener('click', function() {
			activeIndex = activeIndex - 1 >= 0 ? activeIndex - 1 : $slides.length - 1;
			handleChange();
		}, false);

		/**
		 * Touches
		 */
		var clientXDown, clientYDown;
		var followed = 0;

		function handleMoveStart(x, y) {
			clientXDown = x;
			clientYDown = y;
			$container.setAttribute('data-grabbing', true);
		}

		function handleMove(clientX, clientY, e) {
			if (clientYDown && clientXDown) {
				var xDiff = clientXDown - clientX;
				var yDiff = clientYDown - clientY;

				if (xDiff && yDiff) {
					e.preventDefault();
					e.stopPropagation();
					followed = (xDiff / $container.offsetWidth) * 100;
					$container.setAttribute('style', transform + ': translateX(' + ((activeIndex * -100) + (followed * -1)) + '%);');
				}
			}
		}

		function handleMoveEnd(e) {
			if (followed !== 0) {
				e.preventDefault();
				e.stopPropagation();
			}

			if (followed < -35) {
				activeIndex = Math.max(0, activeIndex + Math.floor(followed / 100));
			} else if (followed > 35) {
				activeIndex = Math.min(length - 1, activeIndex + Math.ceil(followed / 100));
			}

			$container.setAttribute('data-grabbing', false);
			handleChange();
			clientXDown = 0;
			clientYDown = 0;
			followed = 0;
		}

		function handleTouchStart(e) {
			handleMoveStart(e.touches[0].clientX, e.touches[0].clientY, e);
		}

		function handleTouchMove(e) {
			handleMove(e.touches[0].clientX, e.touches[0].clientY, e);
		}

		function handleMouseDown(e) {
			handleMoveStart(e.clientX, e.clientY, e);
		}

		function handleMouseMove(e) {
			handleMove(e.clientX, e.clientY, e);
		}

		function handleDragStart(e) {
			e.preventDefault();
			e.stopPropagation();
		}

		$container.addEventListener('mousedown', handleMouseDown, false);
		$container.addEventListener('touchstart', handleTouchStart, false);
		$container.addEventListener('touchend', handleMoveEnd, false);
		$container.addEventListener('dragstart', handleDragStart, false);
		window.addEventListener('touchmove', handleTouchMove, false);
		window.addEventListener('mousemove', handleMouseMove, false);
		window.addEventListener('mouseup', handleMoveEnd, false);
		window.addEventListener('click', handleMoveEnd, false);
		handleChange();
	})()
</script>

